$TITLE ('GALEX/COS Main Executive')
$PAGELENGTH(59)
$SB
$DEBUG
;THIS IS DPU.A51,                             LAST EDITED ::  5-22-100 1:19 pm 
;*****************************************************************************
;
;  EEEEEEE
;  E         X    X   EEEEEE    CCCC    U    U    TTTTT      I     V    V
;  E          X  X    E        C    C   U    U      T        I     V    V
;  EEEEE       XX     EEEEE    C        U    U      T        I     V    V
;  E           XX     E        C        U    U      T        I     V    V
;  E          X  X    E        C    C   U    U      T        I      V  V
;  EEEEEEE   X    X   EEEEEE    CCCC     UUUU       T        I       VV
;
;*****************************************************************************
; v16885 dbb 05-07-00 REORGANIZED! New memory and IVT layout, future
;                     uploads will not be compatable with older versions.
;*****************************************************************************
$SET (MAIN_EXECUTIVE)
$INCLUDE(common.inc)
;
         NAME EXECUTIVE

;*****************************************************************************
IDENTITY SEGMENT CODE
         RSEG IDENTITY

VERSION:     DB 'GALEX/COS v17000   22 May     2000',0
VNUMBER      EQU 17000
CRCPADX:     DB 0FFh,0FFh,0FFh,0FFh ; padding...
COPYRITE:    DB 'Copyright (c) 2000 University of California',0
; This is the designated code space for inserting the CRC adjust value
; that forces the computed CRC to be some constant value recognised
; by the spacecraft/ground support to be the characteristic of valid code.
CRCPADD:     DB 0FFh,0FFh,0FFh,0FFh, 0FFh,0FFh,0FFh,0FFh, 0FFh,0FFh,0FFh,0FFh

;*****************************************************************************
; v16241 dbb 11-25-98 SAA Shutdown skipped if vset is 0, no increase in HV
; v16242 dbb 11-25-98 Added byte for HV ramping
; v16246 dbb 11-30-98 Removed INT_TIME tlm overloading
; v16247 dbb 11-30-98 restored INIT_T0 to get GPFLAG to set every second
; v16251 dbb 12-4-98  door timeout & hvi checking depends on EA flag.
; v16252 dbb 12-4-98  hvi checking histogram in ph.
; v16253 dbb 12-15-98 turns off hv indicators when safing hv controls
; v16254 dbb 12-22-98 latches MUX tlm on HVI trigger
; v16255 dbb 12-22-98 stores HVI readings in circular buffer at C000
; v16256 dbb 12-23-98 HVI algorithm powers off on first overcurrent sample
;                     diags 27,28 retired.
; v16257 dbb 12-24-98 CRC reporting depends on FORMAT bit, presumably unused
;                     in FUSE.
; v16258 dbb 12-24-98 Ramp select initialzed to 15 at REENTRY
; v16260 dbb 12-30-98 Current limit trigger stops a ramp without power-off
; v16261 dbb 12-31-98 LastSample bit reports sample after power-off
; v16263 dbb 01-01-99 Fixed lastsample, ensure all three lastsamples recorded.
; v16264 dbb 01-05-99 Sample index is the same for HVIA HVIB and AuxI
;                     Samples recorded for a short time after power-off
; v16265 dbb 01-06-99 FSTAT now recorded with samples...
; v16266 dbb 01-07-99 Fixed histogram error
;
; v16300 dbb 01-08-99 Default ramp to 0
;                     SAA_FLAGi (BZ) used to disable record-keeping
; v16300 dbb 01-08-99 Released to FUSE project for upload to v16200 in PROM.
; v16400 dbb 01-08-99 Holdoff samples saved properly; CMD_ERR fixed?
; v16402 dbb 01-08-99 Don't let i==255 force power off...
; v16404 dbb 01-08-99 Don't let i==255 force power off...
; v16405 dbb 02-05-99 ASSERTED bit for commanded REDUCE/RESUME, no diag 22,23
;                     ASSERTED to suppress diag 22,23 in REDUCE/RESUME
; v16406 dbb 02-05-99 Telemetry latching an assembly option LATCHTLM
; v16408 dbb 02-06-99 nVERBOSE set on Reentry, Test E; reset on Test D
; v16409 dbb 02-06-99 SAA routines use more calls, to conserve codespace
;                     REDUCE/RESUME works even when SAA_OVERRIDDEN
; v16410 dbb 02-06-99 Restored IDS_UPDATE A/B toggling SAA int time
; v16411 dbb 02-06-99 
; v16412 dbb 02-06-99 No longer shutdown HV if current == 255
;                     Overlimit checking only when HV on
; v16413 dbb 02-07-99 
; v16413 dbb 02-09-99 Dropped FSTAT in favor of timestamping records with CL
; v16414 dbb 02-09-99 Zero lower Code CRC on jmpcode to prevent diagnostic
;                     Restored HIMON to UPDATE_MUX, even if sampled
; v16415 dbb 02-09-99 Added timestamping with CL
; v16417 dbb 02-09-99 Still working on timestamping
; v16418 dbb 02-09-99 Fixed CHECK_I persistence (was one-off in index to word)
;                     Let housekeeping Format bit reflect hardware state
; v16419 dbb 02-09-99 Use SPARE_Sx_CMD commands to work around eGSE limitation
; v16420 dbb 02-09-99 Ramp is 0 by default
; v16424 dbb 02-11-99 overlimit checking bug fixes
; v16425 dbb 02-11-99 Oops, corrected overlimit checking offset
; v16500 dbb 02-12-99 Upload version released.
; v16600 dbb 09-20-99 Upload version moves CRC for UCA to tCRCRAM.
; v16705 dbb 09-22-99 GALEX version, using E000..FFFF for xfer buffer
; v16706 dbb 09-27-99 Fixed RXD_ISR register read order
; v16711 dbb 10-05-99 Fixed TXD register write order
; v16714 dbb 10-19-99 Removed some debug code, added comments
; v16718 dbb 11-04-99 Increased BUSY time
; v16720 dbb 11-23-99 Fixed RXD_ISR for swapped words;
;                     Added some commands;
; v16721 dbb 11-23-99 Suppress CRC checking UCA because of DIB workaround
;                     Lower 32K memory is missing in commercial DIB version.
; v16722 dbb 11-23-99 Improved command reception
;                      by calling CHECKRXDFLAG more often
; v16723 dbb 11-23-99 Continuing to improve command reception by
;                      controlling interrupt enable during reception
; v16724 dbb 11-23-99 Continuing to improve command reception...
; v16727 dbb 11-30-99 Restored old word-order in sync with latest bitfile.
; v16728 dbb 12-01-99 Debugging a cmd/hkp bug
; v16729 dbb 12-01-99 more Debugging a cmd/hkp bug
; v16730 dbb 12-01-99 more Debugging a cmd/hkp bug -- problem found in Actel!
; v16731 dbb 12-02-99 Fixup for more flightlike behaviors...
; v16732 dbb 12-02-99 Repaired stack check to allow for bad RAM 
;                     (now uses internal data)
; v16733 dbb 12-02-99 Still working on stack check...
; v16734 dbb 12-02-99 Misc cleanup...
; v16735 dbb 12-03-99 Compiler control to include v16730 debug housekeeping
; v16736 dbb 12-03-99 Moved SIO and EX0 checking into BACKGROUND
; v16737 dbb 12-03-99 Slight change to wd-test
; v16738 dbb 12-03-99 Support for high-speed hkp packets
; v16739 dbb 12-04-99 Fixed a bug in RXD_ISR, retest with Rev B Actel design
; v16740 dbb 12-05-99 Reorganized mainroutine and timers to make it easier
;                     to document the design of the mainroutine.
; v16741 dbb 12-06-99 Repaired tLFPINTA
; v16742 dbb 12-06-99 Changed code references from Sx_INT_TIME to tLFPINTx
;                     Retained data references to Sx_INT_TIME for FUSE compatability
; v16743 dbb 12-13-99 Added HKPFULL and hkp changes only
; v16750 dbb 01-19-00 Developing memory monitors...
; v16752 dbb 01-19-00 Developing counters...
; v16754 dbb 01-20-00 Developing counters...
; v16763 dbb 01-28-00 Corrected +/- 15V monitors MUX source EQU
; v16764 dbb 01-31-00 ISR vectors jump through RAm area
; v16767 dbb 01-31-00 Checking out lvps & hvps sensors, hv setting
; v16769 dbb 02-02-00 Added serial numbers to diagnostics
; v16770 dbb 02-02-00 Modified stack check constants to account for changes
; v16771 dbb 02-03-00 Init code w/d state and reset counter added
; v16775 dbb 02-09-00 Developing a init code that is COS-like for the
;                     COS breadboard, and GALEX-like for the commercial DIB
;                     Detected by reading MUX and testing for FF (COS)
; v16778 dbb 02-10-00 Filled unused space with jumps to trap
; v16784 dbb 02-24-00 Rewrote MUX/A2D code, separated code & data
; v16791 dbb 02-29-00 Debugging counters
; v16794 dbb 02-29-00 PROJECT bit uses PH-B data to determine if we are
;                     COS or GALEX
; v16803 dbb 03-07-00 Corrected PROJECT sense to COS=0, GALEX=1
; v16816 dbb 03-10-00 Still trying to figure out how to detect PROJECT sense
; v16822 dbb 03-15-00 COS redundant hkp/cmd channel supported
; v16835 dbb 03-26-00 IVTs in RAM updated to point reset vector to REENTRY
; v16838 dbb 03-28-00 Now using 8k RAM for all cmd/hkp i/o
; v16839 dbb 03-29-00 A little clean up, removal of debug and xxx code
; v16842 dbb 04-01-00 Understanding better the hardware layouts: using
;                     project bit to determine which set of items to MUX
;                     because in some cases, the same MUX source is reported
;                     in different hkp locations vis-`a-vis GALEX/COS
; v16845 dbb 04-03-00 Rewrote CDC commanding scheme to support differing
;                     layouts in Digitizer/TDC.  Pursuant to design goals,
;                     the TDC layout is specified in a table of commands
;                     that pairs equilvalent GALEX/COS Digitizer/TDC commands.
; v16848 dbb 04-12-00 Fix a few bugs:.
; v16860 dbb 04-12-00 Added HV I limit checking
; v16874 dbb 05-01-00 Upload to v16870
; v16880 dbb 05-04-00 Stim commands developed
; v16882 dbb 05-05-00 Added side B TDC Sampling and Control;
;                     MON51 permanently removed!  Data Area now used as IVT.
;                     Boot Mode: Initializing IVTs in 32k memory
;                     Many commands check for bootmode
;                     SPECIALF to control BYTE_MOVE source memory type 
;                     Boot Mode: OPERATES flag set, allow HV shutoff on reset.
; v16885 dbb 05-07-00 REORGANIZED! New memory and IVT layout, future
;                     uploads will not be compatable with older versions.
; v16902 dbb 05-17-00 Reassigned ESS_FLAG to control hkp packet size
; v16906 dbb 05-18-00 Added 5 us to CONVERT_A2D routine
; v16907 dbb 05-18-00 Removed timestamps on hkp packets
; v17000 dbb 05-22-00 Code Review Version
;***********************************************************************
AUTONOMY   SEGMENT CODE PAGE
         RSEG AUTONOMY

    JMP    REENTRY            ; this will never happen, right?

;*****************************************************************************
; This is the handshake for the IDS, indicating that the DPU is no longer
;   using the dual-port memory shared with the 1533/IDS
;*****************************************************************************
;  Let's see if I got this right:  There are two sets of counters, each
;    counter is 24-bits or 3-bytes -- but they are located at 4-byte
;    intervals.  Each set of counters has just two: SiCa & LiFl.
;*****************************************************************************
MV2REG MACRO regid
    MOVX   A,@DPTR            ; fetch the byte from counter
    MOV    regid,A            ; save the byte in a register
    INC    DPTR               ; point to the next-byte
    ENDM                      ; MV2REG

;*****************************************************************************
REG2DP MACRO regid
    MOV    A,regid            ; fetch the byte from a register
    MOVX   @DPTR,A            ; load value to memory
    INC    DPTR               ; point to the next-byte
    ENDM                      ; REG2DP

;*****************************************************************************
; Note: R3 should be 0, since counters are 24-bits -- right?
MOV_COUNTER MACRO ctr_addr, ts_addr
    MOV    DPTR,#ctr_addr     ; load the address of the counter
    MV2REG R0                 ; save in a register
    MV2REG R1                 ; save in a register
    MV2REG R2                 ; save in a register
    MOV    DPTR,#ts_addr      ; load the address of the destination
    REG2DP R0                 ; load from register to memory
    REG2DP R1                 ; load from register to memory
    REG2DP R2                 ; load from register to memory
    REG2DP R3                 ; always 0
    ENDM                      ; MOV_COUNTER

;*****************************************************************************
;  The PCA is CH:CL at F9h and E9h
MOV_TIMER MACRO dest_addr
    MOV    A,CL               ; fetch CL, low byte of PCA timer
    STOREX dest_addr          ; Timer destination, store the low-byte
    MOV    A,CH               ; fetch CH, high byte of PCA timer
    STORNEXT
    ENDM                      ; MOV_TIMER


;*****************************************************************************
TOGGLEPHD:                    ; de/assert the appropriate PH_DIS line 
    JNB    PROJECT,COSPHD
    CPL    GPHDIS
    AJMP   GALPHD
COSPHD:
    CPL    CPHDIS
GALPHD:
    RET                       ; TOGGLEPHD

UPDATE_CTRS:   ; Copy counters to subaddress 26... no parameters
    MOV    R3,#0              ; bits 24-32 are always 0

; Timer??  I think this is supposed to be the free running PCA.
    MOV_TIMER TS26            ; Save timer value update_ctrs
; Upper word roll-over was left out of DPU162.  Included here as a fix.
; Note a potential bug: rollover detection depends on regular polling by IDS.
    ; ch in a, if ch < last_ch then do rollover
    ; last_ch = ch
    CJNE   A,LAST_CH,SETCFLAG ; set or reset C
SETCFLAG:
    JNC    INANYCASE          ; rollover not detected
    PUSH   ACC                ; Save ACC because INCREMENT_WORD changes ACC
    MOV    DPTR,#TS26+2       ; point to upper word
    CALL   INCREMENT_WORD     ; tally rollover
    POP    ACC		      ; restore ACC because INCREMENT_WORD changes ACC
INANYCASE:
    MOV    LAST_CH,A          ; save for rollover test
   
    CALL   TOGGLEPHD          ; assert the appropriate PH_DIS line 
    MOV    DPTR,#COUNTERTABLE ; point to a table of sources, dests, and lengths
    CALL   TABLE_COPY
;
    FETCHX TENCOUNT           ; get the current count down timer
    JNZ    NORELOAD           ; do I need to reload count down?
    MOV    A,#10              ; ten seconds?
NORELOAD:
    DEC    ACC                ; subtract 1 from counter
    STOREX TENCOUNT           ; update the current count down timer
;
    JB     MUX_FLAG,SKIPPHDS  ; allow debug disable
    JB     PROJECT,EVERYTIME  ; COS reads PH every second, GALEX every ten
    JNZ    SKIPPHDS           ; look at ACC, count down timer
EVERYTIME:
    MOV    DPTR,#PHTABLE      ; point to a table of sources, dests, and lengths
    CALL   TABLE_COPY
    FILL_XDATA 0,PH_SLICE_0,PH_SLICE_0+256
SKIPPHDS:
    CALL   TOGGLEPHD          ; de-assert the appropriate PH_DIS line 
    RET                       ; UPDATE_CTRS

;*****************************************************************************
DELAY_20:
    CALL   BACKGROUND         ; check SIO, EX0 and CRC
    SPARE_CODE 34
    RET                       ; DELAY_20

;*****************************************************************************
CONVERT_A2D:
    PUSHDPTR
;
    MOV    A,DPL              ; MUX select encoded in address
    MOVX   @DPTR,A            ; select input channel	    -- WRITE!
    SETB   fFORMAT	      ; debug dbb 5-18-00
    CALL   CHECKRXDFLAG       ; detect opcode, stash command buffer
    CALL   DELAY_20           ; 20us enough time for conversion
    STOREX ADC_SPACE          ; AD converter, start AD convert -- WRITE!
    CALL   DELAY_20           ; 20us enough time for conversion
;
    MOVX   A,@DPTR            ; fetch result                -- READ!
    CLR    fFORMAT            ; debug dbb 5-18-00
    MOV    DPL,R2             ; restore dest
    MOV    DPH,R3   	      ; restore dest
    MOVX   @DPTR,A            ; stash result in memory      -- WRITE!
;
    POPDPTR
    PUSH   ACC
    MOV    A,#44h             ; debug select GND2
; debug dbb 11-11-99
; CLR    A                  ; A <-- 0
    MOVX   @DPTR,A            ; deselect MUX                -- WRITE!
    POP    ACC
    RET                       ; CONVERT_A2D

;*****************************************************************************
; Converts selected MUX line and puts result in destaddr
FETCH_ADC MACRO srcaddr,destaddr
LOCAL skip1,skip2
    MOV    R2,#LOW(destaddr)  ; actually save in a register
    MOV    R3,#HIGH(destaddr) ; actually save in a register
    MOV    DPTR,#srcaddr      ; load the selected MUX line (& select ADC)
    CALL   CONVERT_A2D
    ENDM                      ; FETCH_ADC

;*****************************************************************************
; Selects an analog input from MUX on CDC board
FETCH_SDP MACRO CDC_OUT,TDC,MUXname,TS27dest
                                  ;   A  holds CDC command
                                  ;   R0 holds data parameter
                                  ;     no parameter required for MUX select.
    MOV    A,#MUXname         ; select the MUX on Science Data Processor
    CALL   CDC_OUT            ; select the proper CDC and set MUX there
    FETCH_ADC TDC,TS27dest    ; now get the ADC value from interface board
    ENDM                      ; FETCH_SDP


;*****************************************************************************
FNEXTC:
    INC    DPTR               ; point to next
FETCHC:
    CLR    A                  ; zero
    MOVC   A,@A+DPTR          ; get pointed-to value
    RET                       ; FETCHC

;*****************************************************************************
; This routine was embedded in UPDATE_MUX before v16910, but created here
; in support of test commands that probe individual A2D sensors.
GETMUXINFO:
    CALL   FETCHC             ; get lower-byte of MUX specifier
    JZ     MUXDONE            ; bail out when data pointed-to is zero
    MOV    R5,A               ; save MUX specifier
    CALL   FNEXTC             ; get upper byte of MUX specifier
    MOV    R4,A               ; save upper byte of MUX specifier
    CALL   FNEXTC             ; get lower byte of hkp destination
    MOV    R3,A               ; save lower byte of hkp destination
    CALL   FNEXTC             ; get lower byte of hkp destination
    MOV    R2,A               ; save lower byte of hkp destination
    MOV    A,R5               ; look at upper byte of MUX specifier again
    RLC    A                  ; put most-significant bit in C to determine
    JNC    NOT_TDC            ;  if we have to program TDC MUX to get result
; This is a special case of MUX specifier that indicates the TDC must be
; programmed to select the correct TDC MUX source.  The MUX specifier itself
; has the ms-bit turned on to indicate the data structure has 3 elements,
; instead of the regular 2.
    MOV    A,R5               ; look at upper byte of MUX specifier again
    ANL    A,#7Fh             ; turn off indicator bit
    MOV    R5,A               ; save upper byte of MUX specifier
    CALL   FNEXTC             ; get upper byte TDC MUX specifier (s/b 0)
    MOV    R6,A               ; save TDC MUX specifier
    CALL   FNEXTC             ; get lower byte TDC MUX specifier
    MOV    R7,A               ; save TDC MUX specifier
                              ; R0 is data to TDC MUX, don't care
; We determine which CDC to call by looking at the ms-bit of the ls-byte (R6)
; which we know is cleared for U18 (40h) and set for U19 (80h)
$IF XXX
    PUSH   ACC                ; need to use ACC for selecting CDC side A or B
    MOV    A,R4               ; not sure about this...
    ANL    A,#40h             ; check for U18 selected, use side A
    SETB   SPECIALF           ; borrowing this flag for local use
    JZ     SETSPECF           ;  else use side B
    CLR    SPECIALF           ; borrowing this flag for local use
SETSPECF:
    POP    ACC                ; restore CDC command to ACC
    JBC    SPECIALF,USE_TDC_B ; flag indicates B side
$ELSE
    SPARE_CODE 16
$ENDIF

    CALL   CDC_A_OUT          ; A holds TDC command, R0 parameter not needed
    AJMP   NOT_TDC            ; now go read the ADC
USE_TDC_B:
    CALL   CDC_B_OUT          ; A holds TDC command, R0 parameter not needed
NOT_TDC:		      ; now go read the ADC
    INC    DPTR               ; point to low byte of next MUX specifier
    PUSHDPTR		      ; save pointer to next MUX specifier
    MOV    DPL,R4             ; load pointer with MUX specifier
    MOV    DPH,R5             ; load pointer with MUX specifier
    CALL   CONVERT_A2D        ; expects DPTR and R3:R2
    POPDPTR		      ; restore pointer to next MUX specifier
    RET                       ; GETMUXINFO:

;*****************************************************************************
UPDATE_MUX:
    JB     PROJECT,USEGTABLE  ; determine which table to use
    MOV    DPTR,#CMUXTABLE    ; the list of items to be sensed and stored.
    JMP    MUXLOOP
USEGTABLE:
    MOV    DPTR,#GMUXTABLE    ; the list of items to be sensed and stored.
MUXLOOP:
    CALL   GETMUXINFO
    JMP    MUXLOOP            ; do the next one...
MUXDONE:
    RET                       ; UPDATE_MUX

;*****************************************************************************
NEXTBYTE:
    INC    R0                 ; point to high-byte source
    MOV    A,@R0              ; fetch high byte
    STORNEXT	              ; point to high-byte destination
    RET                       ; NEXTBYTE

;*****************************************************************************
COUNTEVENTS MACRO srcptr, sumptr
  LOCAL SUM_A,NOROLL_A
; Count total number of events 
    MOV    DPTR,#srcptr
    CLR    A                  ; A <-- 0
    MOV    R2,A		      ; accum at 0
    MOV    R1,A               ; accum at 0
    MOV    R0,A	              ; 256 bytes to count
    CLR    C                  
SUM_A:
    MOVX   A,@DPTR
    ADD    A,R1
    MOV    R1,A
    JNC    NOROLL_A
    CLR    C
    INC    R2
NOROLL_A:
    INC    DPTR
    DJNZ   R0,SUM_A
    MOV    A,R1
    STOREX sumptr
    MOV    A,R2
    STORNEXT
    ENDM                      ; COUNTEVENTS
    
;*****************************************************************************
ESSENTIAL:                    ; Assorted monitors
;   D16   PC         Packet counter (incremented on each software cycle) 
;   D16   CMD_R      Command 1 response = CMD_1 
;   D16   NUM_R      Serial number of the command in reference = NUM 
;   D16   CSTAT      status: invalid, invalid CRC, stored, executed,... 
;   D16   BACK       readback value (0 if none) 
;   D16   DP_CMD_C   DPU command counter 
;   D16   DP_STATUS  DPU various DPU status bits 
;


;   D1,D1, D1,D3,
;         STIM_ON_A, STIM_ON_B, STIM_MODE,DOOR_POS_A
;                    Stim pulse generator flags and door position monitors (digital)
;                    and analog. 
    FETCHX tUpperBITS1           ; 27 27, high byte, get DOOR_POS_A, D3
    MOV    C,STIM_B_SWEEP_BIT ; Bit-address
    RLC    A                  ; shift that bit into A
    MOV    C,STIM_A_SWEEP_BIT ; Bit-address
    RLC    A                  ; shift that bit into A
    MOV    C,STIM_ON_B_BIT    ; Bit-address
    RLC    A                  ; shift that bit into A
    MOV    C,STIM_ON_A_BIT    ; Bit-address
    RLC    A                  ; shift that bit into A
    STOREX tSTATUS_BITS3           ; STIM_ON_A, STIM_ON_B, STIM_MODE,DOOR_POS

    RET                       ; ESSENTIAL
 
;*****************************************************************************
;  The idea here is to test for excessive counts and, if detected, reduce the
;  HV for some specified interval.  Segments A and B are treated separately.
;  Excessive counts is defined as greater than SA_CNT_LMT counts within
;  SA_INT_TIME.  If the condition is detected, the HV for that segment is
;  set to SA_REDUCED for a duration of SAA_TIMEOFF, after which it is reset
;  to the previous value.  Note that if a command changes the HV for a segment
;  then that also terminates the reduced duration without restoring the
;  previous value.
;*****************************************************************************
REDUCE_HV MACRO s_reduced, hv_dac, s_state, vset
LOCAL NO_INCREASE            
    PUSH   0
    FETCHX vset               ; this is our current setting, right?
    JZ     NO_INCREASE        ; if vset is 0, then we shouldn't change it.
    FETCHX s_reduced          ; load reduced value
    MOV    R0,A               ; load reduced value
    SETB   F0                 ; signal to avoid saving OLD_x_DAC
    CALL   hv_dac             ; set HV
    SETB   s_state	      ; autonomous shutdown active
NO_INCREASE:                  ; dbb 11-25-98, check vset before shutdown
    POP    0
    ENDM                      ; REDUCE_HV

;*****************************************************************************
RDIAG0023:
    JB     ASSERTED,NOREPORT  ; we don't report this if it was commanded
    REPORT_DIAG DIAG0023      ; SAA shutdown completed, restored
NOREPORT:
    RET                       ; RDIAG0023

;*****************************************************************************
RDIAG0022:
    JB     ASSERTED,RCHECKED  ; we don't report this if it was commanded
    REPORT_DIAG DIAG0022      ; SAA shutdown activated
RCHECKED:
    RET                       ; RDIAG0022

;*****************************************************************************
SAA_TRIGD MACRO hv_dac,s_state,saa_ticks,skip_label,vset,saa_init
LOCAL NO_SHUTDOWN,TIMER_EXPIRED,CALC_IT,NOREPORT
    JNB    s_state,NO_SHUTDOWN ; check for autonomous shutdown active
    JB     S_OVER,TIMER_EXPIRED ; artificial trigger for OVER
    FETCHX SAA_TIMEOFF
    MOV    R0,A               ; low byte
    FETCHNEXT
    MOV    R1,A               ; high byte
; first, if SAA_TIMEOFF == 0, then we never restore HV
    CJNE   A,0,CALC_IT        ; if R0 <> R1, they ain't 0
    JNZ    CALC_IT	      ; obviously not 0
    JMP	   skip_label         ; 0, don't check for SAA either
    
CALC_IT:
; we are calculating TICKS - SAA_TIMEOFF, normally negative, carry bit set
    MOV    DPTR,#saa_ticks    ; pointer to word to be incremented
    CALL   INCREMENT_WORD     ; changes ACC, C
    FETCHX saa_ticks          ; get the LSB of saa_ticks
    CLR    C                  ; no borrow, yet
    SUBB   A,R0               ; set borrow flag, C, as appropriate
    FETCHNEXT	              ; high byte of tick-counter
    SUBB   A,R1               ; borrow indicates ticks less than timeoff
    JNC    TIMER_EXPIRED      ;
    JMP    skip_label

TIMER_EXPIRED:
; timer expired...
    JB     SAA_ASSERT,NO_SHUTDOWN ; if SH flag, operator doesn't want turn on
    CALL   saa_init           ; fill table with frogs, ensure valid shutdown
    CLR    A                  ; A <-- 0
    STOREX saa_ticks	      ; zero tick-counter
    STORNEXT	              ; zero tick-counter
    FETCHX vset		      ; use saved value for restore
    MOV    R0,A		      ; saved value
    CALL   hv_dac	      ; restore HV
    CALL   RDIAG0023

    JMP    skip_label
NO_SHUTDOWN:
    ENDM                      ; SAA_TRIGD

;*****************************************************************************
CALCDIFF:
    CLR    C
    MOVX   A,@DPTR            ; fetch lsb
    SUBB   A,R2               ; throw away result except borrow in C
    FETCHNEXT                 ; fetch xsb
    SUBB   A,R3		      ; throw away result except borrow in C
    FETCHNEXT                 ; fetch msb
    SUBB   A,R6		      ; throw away result except borrow in C
    INC    DPTR
    RET                       ; CALCDIFF

;*****************************************************************************
LOADCNTS:
    MOV    R2,A               ; stash it away in a register
    FETCHNEXT
    MOV    R3,A               ; stash it away in a register
    FETCHNEXT
    MOV    R6,A               ; stash it away in a register
    RET                       ; LOADCNTS

;*****************************************************************************
CALCEK:
    MOV    TEMP,A             ; get LSB, save in internal memory
    FETCHNEXT
    MOV    TEMP1,A	      ; get MSB, save in internal memory
    POPDPTR
    MOV    A,R2
    ADDC   A,TEMP             ; use LSB
    MOVX   @DPTR,A
    MOV    A,R3
    ADDC   A,TEMP1            ; use MSB
    STORNEXT
    MOV    A,R6
    ADDC   A,R1               ; R1=0
    STORNEXT
    RET                       ; CALCEK

;*****************************************************************************
; saa_k * 3 + base == new prediction location
CALC_ITEMS:
    PUSH   B
    MOV    B,#3               ; number of bytes per item
    MUL    AB
; Add offset to base to calculate actual address of expiration value Ek
    ADDC   A,DPL
    MOV    DPL,A
    MOV    A,B
    POP    B
    ADDC   A,DPH
    MOV    DPH,A
    RET                       ; CALC_ITEMS

;*****************************************************************************
; we are adding three bytes to two bytes, result is three bytes stored at DPTR
ADD3BYTE:
    MOV    A,R2
    ADDC   A,TEMP             ; use LSB
    MOVX   @DPTR,A
    MOV    A,R3
    ADDC   A,TEMP1            ; use MSB
    STORNEXT
    MOV    A,R6
    ADDC   A,R1               ; R1=0
    STORNEXT
    RET                       ; ADD3BYTE

;*****************************************************************************
LOADTEMP:
    MOV    TEMP,A             ; get LSB, save in internal memory
    FETCHNEXT
    MOV    TEMP1,A	      ; get MSB, save in internal memory
    RET                       ; LOADTEMP

;*****************************************************************************
SAA_CHECK MACRO cnt_lmt,saa_counter,s_reduced,hv_dac,saa_table,s_state,saa_k,vset,rflag
LOCAL FORLOOP,CHECKED,CLOOP,DLOOP,SHUTDOWN,GOOD_CNT
;
    JB     S_TRIGR,SHUTDOWN   ; artificial trigger for HERE
    FETCHX saa_counter
    CALL   LOADCNTS           ; put saa_counter in R6:R3:R2
    MOV    DPTR,#saa_table
FORLOOP:
; determine if we should jump to shutdown
    CALL   CALCDIFF           ; saa_counter - saa_table[i]
    JNC    GOOD_CNT           ; a borrow indicates a negative comparison
; Now here it is possible to catch a rollover (false) trigger, avoid shutdown.
; if A is 00 and R6 is FF, then the CY flag was set because of a rollover,
;  so, we ignore the rollover...  A justification is required:
;   1. The number of counts allowed per sample must be less than 65536
;   2.  but R6 holds bits 17-24, so R6 will never increase by more than one
    DEC    A                  ; if A was 0, now it is FF
    CJNE   A,6,SHUTDOWN       ; so if R6 is FF too, then we ignore CY

GOOD_CNT:
    DJNZ   R1,FORLOOP
; now calculate the next Ek expiration time
;
    FETCHX saa_counter	      ; get LSB
    CALL   LOADCNTS           ; put saa_counter in R6:R3:R2
; Calculate the number of bytes to offset from base saa_table
    MOV    DPTR,#saa_table
    MOV    A,saa_k            ; saa_k
    CALL   CALC_ITEMS	      ; saa_k * 3 + base == new prediction location
; Now calculate the Ek time for this slot
    PUSHDPTR
    FETCHX cnt_lmt
    CALL   LOADTEMP
    POPDPTR
; with  table ptr in DPTR, and TEMP & TEMP1 have count limit value,
;  we can add the current counter values to count limit and store it in table
    CALL   ADD3BYTE
    JMP    CHECKED
    
SHUTDOWN:
    CLR    rflag              ; stop any ramp in progress
    REDUCE_HV s_reduced, hv_dac, s_state, vset
    CALL   RDIAG0022
CHECKED:
    NOP
    ENDM                      ; SAA_CHECK

;*****************************************************************************
SAA_INDEX MACRO int_time,saa_k
LOCAL SKIP_00,SKIP_01
    FETCHX int_time           ; this is the number of bins used in SAA_TABLE
    INC    saa_k
    CJNE   A,saa_k,SKIP_00
    MOV    saa_k,#0           ; if equal, wrap to 0
SKIP_00:
    JNC    SKIP_01            ; check if int_time < saa_k
    MOV    saa_k,#0           ; int_time must always be greater than saa_k
SKIP_01:
    MOV    R1,A               ; this is the number of bins used in SAA_TABLE
    ENDM                      ; SAA_INDEX

;*****************************************************************************
SAA_ACTIVE MACRO s_override, skip_s, s_int_time
LOCAL INACTIVE, ACTIVE, GO_S
    JB     ASSERTED, GO_S     ; if we are responding to a command, just do it
; First Test for user settings...
    FETCHX s_int_time         ; SAA Integration Time for Count Limit
    JZ     INACTIVE
    AJMP   ACTIVE
INACTIVE:
    JMP    skip_s
ACTIVE:
    JNB    s_override,GO_S    ; When set, AUTO reduce is disabled
    JMP    skip_s
GO_S:
    ENDM                      ; SAA_ACTIVE

;*****************************************************************************
SAA_A_INIT:
    FILL_XDATA 0FFh,SAA_TABLE_A,SAA_TABLE_A+300h
    CLR    A
    MOV    SAA_K_A,A          ; zero index
    CLR    SA_STATE
    RET                       ; SAA_A_INIT

;*****************************************************************************
SAA_B_INIT:
    FILL_XDATA 0FFh,SAA_TABLE_B,SAA_TABLE_B+300h
    CLR    A
    MOV    SAA_K_B,A          ; zero index
    CLR    SB_STATE
    RET                       ; SAA_B_INIT

;*****************************************************************************
SAA_TEST:
    SAA_ACTIVE SA_OVERRIDE,SKIP_SA,tLFPINTA
    SAA_TRIGD HV_A_DAC,SA_STATE,SAA_A_TICKS,SKIP_SA,SA_SAVED,SAA_A_INIT,CTRS_FLAG
    SAA_INDEX tLFPINTA,SAA_K_A
    SAA_CHECK SA_CNT_LMT,SA_MON,SA_REDUCED,HV_A_DAC,SAA_TABLE_A,SA_STATE,SAA_K_A,SA_SAVED,CTRS_FLAG
                              ; SET BITS FOR MCP-A HV BIAS
SKIP_SA:
    SAA_ACTIVE SB_OVERRIDE,SKIP_SB,tLFPINTB
    SAA_TRIGD HV_B_DAC,SB_STATE,SAA_B_TICKS,SKIP_SB,SB_SAVED,SAA_B_INIT,PHS_FLAG
    SAA_INDEX tLFPINTB,SAA_K_B
    SAA_CHECK SB_CNT_LMT,SB_MON,SB_REDUCED,HV_B_DAC,SAA_TABLE_B,SB_STATE,SAA_K_B,SB_SAVED,PHS_FLAG

SKIP_SB:
    CLR    S_TRIGR            ; artificial trigger for HERE/OVER
    CLR    S_OVER             ; artificial trigger for HERE/OVER
    RET                       ; SAA_TEST

;*****************************************************************************
CHEKRAMP MACRO ramp_flag,rampcnt,target,setting,hvroutine,rmpcmd
LOCAL incstep, sethv, notramping, endramp, takeastep
  ; ramp_flag for HV ramping
  ; rampcnt countdown for HV ramp
  ; target target HV for HV ramp
  ; setting setting HV for HV ramp
    FETCHX rampcnt              ; this counter tells us how long to
    JNB    ramp_flag,notramping ; if the rampflag isn't set, we aren't ramping!
    DEC    ACC                ; count a second
    JBC    rmpcmd,takeastep   ; check the bit, if set jump and clear
    JNZ    notramping         ;  wait between increases to hv settings
; on 0, it is time to take a step
; so we calculate setting-target
;  if (target-setting) is 0, we are done and jump to end ramp
;  if (target-setting) > 0, we increment setting and pass it to hvroutine
;  if (target-setting) < 0, hv is decreasing at once to target
takeastep:
    CLR    C                  ; no borrow, yet
    FETCHX setting
    MOV    R0,A               ; setting in R0
    FETCHX target             ; target in A
    SUBB   A,R0               ; calculate (target-setting) in A
    JZ     endramp            ; we are done, hv on target.
    JNC    incstep            ; C indicates borrow, or target < setting.
    FETCHX target             ; target in A
    MOV    R0,A               ; target in R0
    AJMP   sethv              ; set hv to target
incstep:                      ; target > setting
    INC    R0                 ; increment setting by a step
sethv:
    SETB   F0                 ; don't update vset when changing dac
    CALL   hvroutine          ; update the dac setting
    MOV    A,HVRAMP           ; HV_Ramp constant, 0 disables ramping
    JNZ    notramping         ; if HVRAMP is 0, then ramping is disabled
endramp:
    CLR    ramp_flag          ; turn ramping off  		  
notramping:                   ; routine exit
    STOREX rampcnt            ; whatever in A is countdown from HVRAMP to zero
    ENDM                      ; CHEKRAMP

;*****************************************************************************
CHECK_RAMP:                   ; autonomous HV ramping
    CHEKRAMP CTRS_FLAG,HVArampcnt,tLFHVTGTA,HVAsetting,HV_A_DAC,RAMPACMD
    CHEKRAMP PHS_FLAG,HVBrampcnt,tLFHVTGTB,HVBsetting,HV_B_DAC,RAMPBCMD
    RET                       ; CHECK_RAMP autonomous HV ramping

;*****************************************************************************
FETCH_LATCHED_BIT:
    JB     MUX_FLAG,FLB_TS    ; read from dest if MUX_FLAG is set
    FETCHX MUX                ; fetch door status bits
    AJMP   FLB_MUX
FLB_TS:
    FETCHX tUpperBITS1           ; 29 25, per v132, result in A
FLB_MUX:
    ANL    A,#1               ; mask out all bits except LATCHED
    RET                       ; FETCH_LATCHED_BIT

;*****************************************************************************
CHECK_ACT_LATCH:              ; We assume this happens exactly once per second
; This is a state machine that detects a LATCHED-to-UNLATCHED transition, and
; in the event will wait 2-seconds then turn off power to the actuators.
; The state variable is AL_STATE:
;                          0       Initial state, waiting for LATCHED = 1
;                          1       Waiting for LATCHED = 0
;                          2       One second
;                          3       Two, turn off power
; and state transitions look like this 0 -> 1 -> 1... -> 2 -> 3 -> 0 -> 1...
; State transitions occur only when this routine is called, at one-second
; intervals.
;
    FETCHX AL_STATE
    ANL    A,#3               ; modulo 4
    RL     A                  ; multiply by two for jump table
    MOV    DPTR,#AL_TBL       ; Use jump table below to select command
    JMP    @A+DPTR	      ; Execute case depending on AL_STATE
AL_TBL:                       ; 
    AJMP   AL_STATE0          ;   Initial state, waiting for LATCHED = 1
    AJMP   AL_STATE1          ;   Waiting for LATCHED = 0
    AJMP   AL_STATE2          ;   One second
    AJMP   AL_STATE3          ;   Two, turn off power
AL_STATE0:                    ;   Initial state, waiting for LATCHED = 1
    CALL   FETCH_LATCHED_BIT  ; result in A, 0 or 1
    JZ     AL_EXIT            ; Waiting for LATCHED = 1
    ASSIGNB AL_STATE,1        ; Goto state 1
    AJMP   AL_EXIT            ; All done!
AL_STATE1:                    ;   Waiting for LATCHED = 0
    CALL   FETCH_LATCHED_BIT  ; result in A, 0 or 1
    JNZ    AL_EXIT            ; Waiting for LATCHED = 0
    ASSIGNB AL_STATE,2        ; Transition detected! Goto state 2
    AJMP   AL_EXIT            ; All done!
AL_STATE2:                    ;   One second
    ASSIGNB AL_STATE,3        ; Goto state 3
    AJMP   AL_EXIT            ; All done!
AL_STATE3:                    ;   Two, turn off power
    MOV    R0,#0              ; turns power off!
    CALL   cACT_ENA           ; ARMS 28V ACTUATOR PWR SWITCH
    ASSIGNB AL_STATE,0        ; Goto state 0
AL_EXIT:                      ; All done!
    RET                       ; CHECK_ACT_LATCH

;*****************************************************************************
CHECK_ACT_RESET:              ; We assume this happens exactly once per second
; This is a state machine that detects a UNLATCHED-to-LATCHED transition, and
; in the event will wait 2-seconds then turn off power to the motor.
; The state variable is AR_STATE:
;                          0       Initial state, waiting for LATCHED = 0
;                          1       Waiting for LATCHED = 1
;                          2       One second
;                          3       Two, turn off power
; and state transitions look like this 0 -> 1 -> 1... -> 2 -> 3 -> 0 -> 1...
; State transitions occur only when this routine is called, at one-second
; intervals.
    FETCHX AR_STATE
    ANL    A,#3               ; modulo 4
    RL     A                  ; multiply by two for jump table
    MOV    DPTR,#AR_TBL       ; Use jump table below to select command
    JMP    @A+DPTR	      ; Execute case depending on AL_STATE
AR_TBL:                       ; 
    AJMP   AR_STATE0          ;   Initial state, waiting for LATCHED = 0
    AJMP   AR_STATE1          ;   Waiting for LATCHED = 1
    AJMP   AR_STATE2          ;   One second
    AJMP   AR_STATE3          ;   Two, turn off power
AR_STATE0:                    ;   Initial state, waiting for LATCHED = 0
    CALL   FETCH_LATCHED_BIT  ; result in A, 0 or 1
    JNZ    AR_EXIT            ; Waiting for LATCHED = 0
    ASSIGNB AR_STATE,1        ; Goto state 1
    AJMP   AR_EXIT            ; All done!
AR_STATE1:                    ;   Waiting for LATCHED = 1
    CALL   FETCH_LATCHED_BIT  ; result in A, 0 or 1
    JZ     AR_EXIT            ; Waiting for LATCHED = 1
    ASSIGNB AR_STATE,2        ; Transition detected! Goto state 2
    AJMP   AR_EXIT            ; All done!
AR_STATE2:                    ;   One second
    ASSIGNB AR_STATE,3        ; Goto state 3
    AJMP   AR_EXIT            ; All done!
AR_STATE3:                    ;   Two, turn off power
    ASSIGNB AR_STATE,0        ; Goto state 0
    JMP    DOOR_STOP
AR_EXIT:                      ; All done!
    RET                       ; CHECK_ACT_RESET

;*****************************************************************************
CHECK_MOTOR_TICK:

; We are checking the LATCH_FLAG so this autonomous shutoff of the door
;  may be disabled.  Any activity at the door latch results in a door stop.
; This is a form of autonomous protection that can stop the door.
    JB     LATCH_FLAG,NO_L_MACHINE
    CALL   CHECK_ACT_LATCH    ; We assume this happens exactly once per second
    CALL   CHECK_ACT_RESET    ; We assume this happens exactly once per second
NO_L_MACHINE:

; We should be here exactly once per second.
    MOV    A,MOTORTMR         ; check the motor activity timer
    JZ     MOTOR_OFF          ; if already 0, there's nothing to do
    TOGLEDS 40h               ; display test on LEDS
    FETCHX DOOR_IMAX
    JZ     SKIP_ITEST
    MOV    R0,A
    FETCHX tAUX_MON           ; AUX_I_MON was saved here
    CJNE   A,0,MAX_TRIGD      ; max triggered?
    JMP    STOP_TRIGD	      ; max triggered.
MAX_TRIGD:                    ; C  is set when current is less than max
    JNC    STOP_TRIGD	      ; max triggered.
    JMP    SKIP_ITEST
STOP_TRIGD:
    REPORT_DIAG DIAG0026      ; AUX_I_MON exceeds DOOR_IMAX
    JMP    DOOR_STOP
END_ITEST:
    NOP
SKIP_ITEST:
;
    TOGLEDS 20h               ; signal activity at LEDs
    DEC    MOTORTMR           ; reflect the passing second
    MOV    A,MOTORTMR         ; check the motor activity timer
    JNZ    MOTOR_OFF          ; if not yet 0, we've done enough!
;
DOOR_STOP:
    MOV    R0,#0              ; M1=M2=0	"Off"
    CALL   BRIDGE_OFF         ; Sets motor bridge switches (direction)
    CALL   MOTOR_ENA          ; Disable motor
    CALL   MOTOR_ARM	      ; Disable motor control, safety on
    CALL   MOTOR_SAFETY_OVERRIDE ; Disable Overrides Endswitches
    CALL   cACT_ENA           ; DISARMS 28V ACTUATOR PWR SWITCH
    CLR    A                  ; Zero MOTORTMR
    MOV    MOTORTMR,A         ; disable motor activity timer
MOTOR_OFF:
    RET                       ; CHECK_MOTOR_TICK

;*****************************************************************************
SIO_VERSION:
    CALL   SIO_CRLF
    MOV    DPTR,#VERSION      ; display version info at SIO
    CALL   SIO_STRING
    RET                       ; SIO_VERSION

;*****************************************************************************
;  dbb 12-2-99 Changed stackAt variable from external to internal variable
;              upon learning that a bug on the breadboard causes continuous
;              reporting of a stack alarm.  This simply points up a failure
;              mode not previously experienced.
; This routine checks the stack to determine if the max height has increased.
StackWarn: DB 'Stack Warning: ',0
CHECK_STACK:                  ; diagnostic only -- no repairs
    PUSH   0                  ; used herein
    CLR    C                  ; make sure this is preset, used below
    MOV    A,stackAt          ; this was initialized to zero at POR
    JNZ    GOOD_NZ_PTR        ; so if it isn't zero, it has been initialized
    AJMP   TEST_MAX_PTR       ; if zero, we need to initialize stackAt
GOOD_NZ_PTR:
    CJNE   A,#90h,TEST_MAX_PTR ; if stackAt is larger than 80h, re-init it
    AJMP   NO_CHANGE          ; forget it! stackAt already reported enough
RESET_PTR:
    MOV    A,#STACK+StakMax   ; reset stack ptr to our best guess
    MOV    stackAt,A          ; store new pointer to stack
    AJMP   PTR_OK             ; assume stackAt is right
TEST_MAX_PTR:
    JNC    RESET_PTR          ; C == stackAt < #80h
PTR_OK:
    MOV    R0,A               ; R0 is passed the stackAt pointer
    MOV    A,@R0              ; and we use the fancy command to fetch from
    JZ     NO_CHANGE          ;  the stack; if the value is 0, then we
    INC    R0                 ;  assume the stack was initialized that way;
    MOV    A,R0               ;  otherwise, we know something was written
    MOV    stackAt,A          ;  and update the stackAt pointer
STACK_ALARM:
    REPORT_DIAG DIAG0007      ; Stack Alarm
    AJMP   NO_CHANGE
TEST_TOP_PTR:
    JNC    STACK_ALARM	      ; Suppress the report if stackAt grows too much
NO_CHANGE:
    POP    0                  ; used herein
    RET                       ; CHECK_STACK

;*****************************************************************************
WAITFORTF2:                   ; ensure a delay between HKP items
; A meter delay is required to keep the max throughput below 16 32-bit words
;  per 5ms interval.  We take that to mean that the up-edge of the GATE signal
;  should be no less than 5000/16 = 312.5 microseconds apart.
; To acheive the delay and meet other autonomous protection requirements,
;  we setup a timer, and loop until the timer expires.
; The Timer 2 (TF2) reload value is the number of 750ns clock-ticks in 312500ns
;  = 312500/750 = 416.7 ==> FE5F.  Used in GALEX for timing constraints.
    PUSH   0
    PUSH   1		      ; used for indexing thru hkp addresses
HKPMETER:
    JBC    TF2,HKPTIMEO       ; TF2 set regularly.    
    CALL   CHECKCMD           ;	  check for command opcodes and set GPFLAG
                              ; Check one-second timer flag for 1Hz activities
    CALL   CHECKFAST          ;   ramping only
                              ; And finally, a background activity
    CALL   BKGACTIVITY        ;   mon51, current limit, crc checking
                              ; Again!
    AJMP   HKPMETER           ; loop until timeout
HKPTIMEO:
    POP    1
    POP    0
    RET                       ; WAITFORTF2 ensure a delay between HKP items

;*****************************************************************************
SENDHKP:                      ; dptr points to value
    PUSH   DPL                ; This is a pointer to data to send, saved
    PUSH   DPH		      ; This is a pointer to data to send, saved
    MOV    HKPBUFF+2,DPL      ;  address LSB stored while changing DPTR
    MOV    HKPBUFF+3,DPH      ;  address MSB stored while changing DPTR
    MOVX   A,@DPTR            ; Fetch the data pointed-to
    MOV    HKPBUFF+0,A	      ; save the data LSB
    INC    DPTR		      ; point to upper data byte
    MOVX   A,@DPTR	      ; Fetch the data pointed-to
    MOV    HKPBUFF+1,A	      ; save the data MSB

; Now we want to xmit only words that have changed since the last send;
;  so we look at the bank of memory assigned to hold an image of the hkp
;  data.  If the data in the image is the same, we can skip this transmission
    JB     HKP_FULL,SENDIT    ; flag means we don't check for new data
    MOV    DPL,HKPBUFF+2      ; restore address LSB stored while changing DPTR
    MOV    DPH,HKPBUFF+3      ; restore address MSB stored while changing DPTR
    XRL    DPH,#8             ; change 1000..17FF to 1800..1FFF
    MOVX   A,@DPTR	      ; Fetch the data pointed-to
    CJNE   A,HKPBUFF+1,HCHANGED ; does data match?
    DEC    DPL                ;  if so, then try lsb
    MOVX   A,@DPTR	      ; Fetch the data pointed-to
    CJNE   A,HKPBUFF+0,LCHANGED ; does data match?
    AJMP   NOSEND             ; if so, then we have nothing new to send from here
HCHANGED:
    MOV    A,HKPBUFF+1        ; prepare MSB for storage
    MOVX   @DPTR,A            ; and salt it away in the image
    DEC    DPL                ;  if so, then try lsb
LCHANGED:
    MOV    A,HKPBUFF+0        ; prepare LSB for storage
    MOVX   @DPTR,A            ; and salt it away in the image

; Now transmit the data
SENDIT:
    JNB    PROJECT,NOWAIT     ; GALEX has some special timing requirements
    CALL   WAITFORTF2         ; ensure a delay between HKP items
NOWAIT:
    MOV    A,HKPBUFF+0        ; fetch data LSB
    STOREX TXD_HARDWARE       ; base Hkp register
    MOV    A,HKPBUFF+1        ; fetch data MSB
    INC    DPH		      ; 5100h is an xmit register
    MOVX   @DPTR,A	      ; put address LSB in xmit register
    MOV    A,HKPBUFF+2	      ; fetch address LSB
    INC    DPH		      ; 5200h is an xmit register
    MOVX   @DPTR,A	      ; put data MSB in xmit register
    MOV    A,HKPBUFF+3        ; fetch address MSB
    ANL    A,#1Fh             ; map to 0000h..1FFFh
    INC    DPH                ; 5300h is MSB xmit register
    MOVX   @DPTR,A	      ; start Hkp xmit
    TOGLEDS 10h               ; signal activity at LEDs
NOSEND:
; Restore DPTR which points to word just transmitted
    POP    DPH                ; points to word data to be transmitted
    POP    DPL		      ; points to word data to be transmitted
    RET                       ; SENDHKP dptr changed

    SPARE_CODE 32  ; linker fix... dbb 4-23-00

;*****************************************************************************
PROGRAMMONITOR:               ; index,addr,bank
; RS17_PAR0 ; index 0..7
; RS17_PAR1 ; addr  0..FFFF
; RS17_PAR2 ; bank  0..3 (0=external code, 1=external data, 2=internal data)
    FETCHX RS17_PAR1          ; put lsb of addr in R2
    MOV    R2,A
    FETCHNEXT                 ; msb in R3
    MOV    R3,A
    FETCHX RS17_PAR2          ; put lsb of bank in R4
    MOV    R4,A
    FETCHX RS17_PAR0          ; put index in A
    ANL    A,#7               ; A = A mod 8
    INC    ACC                ; because we will use DJNZ instruction below
    MOV    R0,A               ; load loop counter with index+1
    MOV    DPTR,#tLFDMADD     ; load pointer to address table
    MOV    A,#1               ; bit mask init to bit 0
    AJMP   PM_WHILE
ADVANCE:
    RL     A                  ; move bit left
    INC    DPTR               ; addresses are words
    INC    DPTR               ; so we advance pointer two bytes
PM_WHILE:
    DJNZ   R0,ADVANCE
    MOV    R5,A               ; save mask in R5
    MOV    A,R2
    MOVX   @DPTR,A            ; put lsb of addr in table
    MOV    A,R3
    STORNEXT
; bank bits
    MOV    A,R4               ; get bank select bits
    ANL    A,#3               ; modulo 4
    RL     A                  ; multiply by two for jump table
    MOV    DPTR,#MM_TBL       ; Use jump table below to select command
    JMP    @A+DPTR	      ; Execute case depending on AL_STATE
MM_TBL:                       ; 
    AJMP   MM_EXT             ;   Data
    AJMP   MM_COD             ;   Code
    AJMP   MM_INT             ;   Registers
    AJMP   MM_BAD             ;   Illegal!
MM_EXT:                       ; External data
    MOV    A,R5               ; get mask bits
    CPL    A                  ; invert the bits to turn one off
    MOV    R1,A               ; save...
    FETCHX tLFDMDATA          ; get current bitmap for data/code
    ANL    A,R1               ; turn bit off
    MOVX   @DPTR,A            ; update bits
    AJMP   MM_BAD             ; turn off EXTR bit
MM_COD:                       ; Code
    FETCHX tLFDMDATA          ; get current bitmap for data/code
    ORL    A,R5               ; turn bit on, get mask bits
    MOVX   @DPTR,A            ; update bits
    AJMP   MM_BAD             ; turn off EXTR bit
MM_INT:                       ; Internal data - bit on!
    CALL   MM_EXT             ; turn off DATA/CODE indicator
    FETCHX tLFDMEXTR          ; get current bitmap for extr/regs
    ORL    A,R5               ; turn EXTR bit on, get mask bits
    MOVX   @DPTR,A            ; update bits
    RET
MM_BAD:                       ; Internal data - bit off!
    MOV    A,R5               ; get mask bits
    CPL    A                  ; invert the bits to turn one off
    MOV    R1,A               ; save...
    FETCHX tLFDMEXTR          ; get current bitmap for data/code
    ANL    A,R1               ; turn bit off
    MOVX   @DPTR,A            ; update bits
    RET                       ; PROGRAMMONITOR
    SPARE_CODE 16

;*****************************************************************************
MEMORYMONITORS:
    PUSH   0                  ; save R0 in case it was in use.
    PUSH   1                  ; save R1 in case it was in use.
    PUSH   2                  ; save R2 in case it was in use.
    MOV    R0,#8              ; number of addresses to monitor
MMVALUE:
    MOV    DPTR,#tLFDMADD     ; starting location of table of addresses
    MOV    A,R0
    MOV    R1,A
    MOV    A,#1               ; mask bit
ADDLP:
    DJNZ   R1,ADDIDX
    AJMP   GETVAL
ADDIDX:
    RL     A                  ; mask bit
    INC    DPTR
    INC    DPTR
    AJMP   ADDLP
GETVAL:
    MOV    R2,A               ; mask bit
    MOVX   A,@DPTR            ; get a byte from table
    PUSH   ACC                ; lower byte of target address
    FETCHNEXT
    PUSH   ACC                ; upper byte of target address
    FETCHX tLFDMEXTR          ; get current bitmap for extr/regs
    ANL    A,R2               ; look at masked bit only
    JZ     NOTREGS            ; if the bit is on, we read internal memory
    POP    DPH                ; upper byte of target address
    POP    DPL                ; lower byte of target address
    PUSH   0                  ; we use R0 for indirect pointer to regs
    MOV    A,DPL
    MOV    R0,A
    MOV    A,@R0              ; get the memory monitor byte from internal regs
    POP    0                  ; restore use as index 0..7
    JMP    GOODENOUGH         ; the fetched data in A

NOTREGS:                      ;   else we read external memory: data or code
    FETCHX tLFDMDATA          ; get current bitmap for data/code
    ANL    A,R2               ; look at masked bit only
    JZ     NOTCODE            ; if the bit is on, we read code space
    POP    DPH                ; upper byte of target address
    POP    DPL                ; lower byte of target address
    CLR    A                  ; zero
    MOVC   A,@A+DPTR          ; get the memory monitor byte value from code
    JMP    GOODENOUGH	      ; the fetched data in A

NOTCODE:                      ;   else we read data memory
    POP    DPH                ; upper byte of target address
    POP    DPL                ; lower byte of target address
    MOVX   A,@DPTR            ; get the memory monitor byte value

GOODENOUGH:		      ; the fetched data in A
    PUSH   ACC                ; save the fetched data/code/whatever
    MOV    DPTR,#tLFDMONS     ; memory monitor values
    MOV    A,DPL
    ADD    A,R0
    ADD    A,#0FFh            ; subtract one...
    MOV    DPL,A
    POP    ACC
    MOVX   @DPTR,A
    DJNZ   R0,MMVALUE         ; are we done yet?
;
    POP    2                  ; restore R2 in case it was in use.
    POP    1                  ; restore R1 in case it was in use.
    POP    0                  ; restore R0 in case it was in use.
    RET                       ; MEMORYMONITORS

;*****************************************************************************
CHECKRXDFLAG:		      ; detect opcode, stash command buffer
    JBC    RXD_FLAG,DOTOGL    ; if there is command activity, toggle LED
    JMP    NOTHINGTODO        ; no RXD_FLAG, so we're done
INITCMDIMAGE:
    MOV    A,#NULL_CMD
    MOVX   @DPTR,A            ; put NULL_CMD in CMDIMAGE to init
    JMP    NOTOGL             ; no update to opcode
DOTOGL:
    PUSHDPTR
    PUSH   ACC
    TOGLEDS 1                 ; dbb 9-21-99 some recognisable pattern to xLEDS
    FETCHX CMDIMAGE           ; has previous command been handled?
    JZ     INITCMDIMAGE       ; 0 in CMDIMAGE means uninitialized
    CJNE   A,#NULL_CMD,NOTOGL ; we don't copy over commands not handled.
    FETCHX RS17               ; fetch command
    JZ     NOTOGL             ; if zero, buffer in power-on state
    CJNE   A,#NULL_CMD,GETIMAGE ; Is there a command to process?
    JMP    NOTOGL             ; no update to opcode
GETIMAGE:
                              ; R0 holds number of bytes to move 
                              ; R3:R2 holds pointer to source
                              ; R5:R4 holds pointer to dest
                              ; F0 selects CRC instead of actual move
    PUSH   0                  ; used elsewhere
    PUSH   1                  ; used elsewhere
    PUSH   2                  ; used elsewhere
    PUSH   3                  ; used elsewhere
    PUSH   4                  ; used elsewhere
    PUSH   5                  ; used elsewhere
    MOV    R2,#LOW(RS17)      ; source
    MOV    R3,#HIGH(RS17)     ; source
    MOV    R4,#LOW(CMDIMAGE)  ; dest
    MOV    R5,#HIGH(CMDIMAGE) ; dest
    MOV    R0,#1Ch            ; R0 holds number of bytes to move 
    CLR    F0                 ; F0 selects CRC instead of actual move
    CLR    SPECIALF           ; we always read from RAM, never ROM
    CALL   BYTE_MOVE          ; copy command buffer to image
    TOGLEDS 2                 ; dbb 9-21-99 some recognisable pattern to xLEDS
    MOV    A,#NULL_CMD        ; Use to indicate no_command, next time
    STOREX RS17               ; Ack command by writing over it
    POP    5                  ; used elsewhere
    POP    4                  ; used elsewhere
    POP    3                  ; used elsewhere
    POP    2                  ; used elsewhere
    POP    1                  ; used elsewhere
    POP    0                  ; used elsewhere
NOTOGL:					
    POP    ACC		      ; used elsewhere
    POPDPTR		      ; used elsewhere
NOTHINGTODO:
    SETB   EX0                ; enable external 0 interrupt
$IF CHANNEL2
    JB     PROJECT,NO2ND      ; check which project
    SETB   EX1                ; enable external 0 interrupt
$ELSE
    SPARE_CODE 5
$ENDIF
NO2ND:
    RET                       ; CHECKRXDFLAG

;*****************************************************************************
IVTPATCH:                     ; copy interrupt vectors from ROM to 8k RAM
    MOV    R0,#40h            ; 64 bytes is the size of the IVT area
    MOV    DPTR,#0h           ; IVT located at address 0 in code area
LLOOP:                        ; We want to loop over the entire IVT area
    CLR    A                  ; This index is always zero, we never use it...
    MOVC   A,@A+DPTR          ; grab a byte from the code area in PROM
    MOVX   @DPTR,A	      ; and drop the same byte in the RAM
    INC    DPTR	              ; then we point to the next address to copy
    DJNZ   R0,LLOOP           ; and copy until all 64 bytes are processed.
; This is a special case interrupt vector that would get executed only if
; the code attempts to execute out of RAM following a reset.  This isn't
; supposed to happen, but it appears that the hardware sometimes gets locked
; in a state in which fetches are referred to the RAM instead of PROM.
    MOV    A,#HIGH(REENTRY)   ; The REENTRY point was chosen since it
    STOREX 1                  ; should re-init itself and operate properly
    MOV    A,#LOW(REENTRY)    ; but it is possible that we could hang because
    STORNEXT                  ; of this choice.  My best guess, dbb 5-5-00.
    RET                       ; IVTPATCH

;*****************************************************************************
PROJECTISR:
$IF XXX     ; removed, but saved for later use... dbb 5-5-00
; A double-check, we look at side and if FF, we know COS hardware isn't
; there, so we must be GALEX.  We do this check because command traffic
; on the B-side channel might be interpreted as the spurious interrupt
; known to happen on GALEX hardware.
    FETCHX COUNTERS_B+3	      ; look at side B counter to see hardware
    CJNE   A,#0FFh,NOTGALEX   ; GALEX will always readback FF
; The first read might clear the counter, so we do it twice.
    MOVX   A,@DPTR     	      ; look at side B counter to see hardware
    CJNE   A,#0FFh,NOTGALEX   ; GALEX will always readback FF
    SETB   PROJECT            ; set to indicate GALEX/DIB-behavior
NOTGALEX:
$ELSE
    CLR    EX1                ; no more interrupts
    SETB   PROJECT            ; set to indicate GALEX/DIB-behavior
$ENDIF
    RETI                      ; PROJECTISR

;*****************************************************************************
SETPROJECT:
; Let's distinguish between GALEX and COS hardware and record it
; We use the first bin of PH side B, address 6300h.  If FF we decide that
; we are GALEX.  This isn't perfect, since DCE-B standalone also reports FF here.
; Since GALEX is the preferred default state, we must prove we are COS hardware.
    MOV    DPTR,#vRXD1ISR     ; install interrupt vector
    FETCHNEXT
    MOV    R4,A               ; save old interrupt vector
    FETCHNEXT
    MOV    R5,A               ; save old interrupt vector
    MOV    DPTR,#PROJECTISR
    PUSH   DPL
    PUSH   DPH
    MOV    DPTR,#vRXD1ISR     ; install interrupt vector
    POP    ACC
    STORNEXT
    POP    ACC
    STORNEXT
    CALL   FEED_DOG           ; set to timeout in ten seconds
    CALL   WD_ENABLE          ; just in case something gets screwed up
                              ; prepare indicator that the interrupt happened
    CLR    PROJECT            ; clear to indicate COS/DCE-behavior
    SETB   EX1                ; in GALEX this will cause an interrupt
    SETB   EA                 ; enable interrupts
    PUSH   0
    MOV    R0,#3              ; 3 * 416us = 1.2ms
STALLING:
    JBC    TF2,TIMEDP
    AJMP   STALLING           ; loop doing nothing while waiting for interval
TIMEDP:
    DJNZ   R0,STALLING        ; wait for another timer interval
    POP    0
;
    MOV    DPTR,#vRXD1ISR     ; install interrupt vector
    MOV    A,R4		      ; restore old interrupt vector
    STORNEXT
    MOV    A,R5               ; restore old interrupt vector
    STORNEXT
;
    RET                       ; SETPROJECT

;*****************************************************************************
STOPXRAMP MACRO rampflag, HVsetting, HVdac
LOCAL STOPRMP
    JNB    rampflag, STOPRMP  ; if we are ramping, we must back-off
    FETCHX HVsetting          ; get current HV setting
    JZ     STOPRMP            ; if the current setting is 0, don't command 255
    DEC    A                  ; reduce HV setting by one
    MOV    R0,A               ; put HVsetting parameter in R0
    CALL   HVdac              ; command the reduced HV setting
    CLR    rampflag           ; turn off ramping
STOPRMP:
    ENDM                      ; STOPXRAMP

;*****************************************************************************
STOP_RAMP:
;    PUSH  ACC                 ; save HVI sample
    STOPXRAMP CTRS_FLAG,HVAsetting,HV_A_DAC
    STOPXRAMP PHS_FLAG,HVBsetting,HV_B_DAC
;    POP   ACC                 ; restore HVI sample
    SETB  C                   ; prevent infinite loop in caller
    RET                       ; STOP_RAMP

;*****************************************************************************
LINDIRECT:                    ; offset in R0, uses R1, restores A
    MOV    DPH,R7             ; table ptr: load base pointer from register
    MOV    DPL,R6             ; table ptr: load base pointer from register
    MOV    R1,A               ; preserve A
    MOV    A,R0               ; offset to lower byte of pointer
    MOVC   A,@A+DPTR          ; fetch lower pointer
    XCH    A,R0               ; save lower, restore offset
    INC    A                  ; offset to upper byte of pointer
    MOVC   A,@A+DPTR          ; fetch upper pointer
    MOV    DPL,A              ; upper
    MOV    DPH,R0             ; lower
    MOV    A,R1               ; restore A
    RET                       ; LINDIRECT

; Use R7:R6 and offset to set DPTR, preserve A, trash R0,R1
LOADOFF MACRO offset    
    MOV    R0,#offset
    CALL   LINDIRECT
    ENDM                      ; LOADOFF

;*****************************************************************************
; This routine detects HV current in excess of limit
; modified dbb 2-5-97 to read from TS to support testing
; modified dbb 7-27-97 to check continuously, power-off HV when pegged, etc.
; transformed from MACRO to call with DPTR to a table of parameters.
;  this routine gets an A2D value, and if it is 255 -- shuts off power.
;  and if the current value is greater than or equal to a set limit, then
;  it reports the event, and if it continues for upto 256 events, will shut off
;  power.  dbb 1-6-98
CHECK_I:                      ; DPTR points to parameter table
    PUSH   0                  ; save R0, whatever it was...
    JB     LASTSAMPLE,CHECKING ; even when HV off, we record sample
    JB     HV_ON_BIT,CHECKING  ; histogram only when power is on
      ; we put this here 'cause we can't fit into the DPU_EXEC segment!
      ; dbb 2-9-99
IDISABLED:
$IF XXX
    FETCH_ADC HIMON_A,     tHI_MON_A ; copy current readings to telemetry
    FETCH_ADC HIMON_B,     tHI_MON_B ; copy current readings to telemetry
$ENDIF
    JMP    TESTiCOMPLETE      ; we do overlimit checking only when HV on

CHECKING:
    MOV    R7,DPH             ; stash base pointer away in register
    MOV    R6,DPL             ; stash base pointer away in register
    MOV    R0,#0              ; DPTR to limit level
    CALL   LINDIRECT
    MOVX   A,@DPTR            ; fetch actual value in ACC
    JZ     IDISABLED          ; check for special feature to disable checking
;
    MOV    R4,A               ; save limit level in register
;
    MOV    R2,#LOW(ISAMPLE)   ; actually save conversion in a register
    MOV    R3,#HIGH(ISAMPLE)  ; actually save conversion in a register
    LOADOFF 2                 ; use R7:R6 and offset to load DPTR from table
    CALL   CONVERT_A2D        ; copy current HV_I reading to temp variable, ACC
    AJMP   NotPegged          ; compare actual HV_I to practical max: pegged?

;--------------------------------------------------------------------------
PWROFF:
; Power-down the HV and report it as a diagnostic
    FETCHX ISAMPLE            ; be sure HVI sample is in A
    LOADOFF 4                 ; get pointer to housekeeping in DPTR
    MOVX   @DPTR,A            ; actual HV_I to telemetry
    CALL   SAFE_CONTROLS      ; command HV power OFF!
    LOADOFF 8                 ; get diagnostic code in DPTR
    CALL   REPORT_DIAGNOSTIC  ; HV_IMAX pegged, HV powered down
    SETB   LASTSAMPLE         ; this sample is recorded, even after power-off
    AJMP   HISTO_SAMPLE       ; drop out, but not before tallying

;--------------------------------------------------------------------------
NotPegged:
; Now we compare the HV_I reading to the max specified by the operator
    CJNE   A,4,M_TRIGD        ; max triggered?

; -----------------------------------------------------------------------
S_TRIGD:                      ; max triggered.
    JB     CTRS_FLAG,STOPRAMP ; if we are ramping, we must back-off
    JB     PHS_FLAG,STOPRAMP  ; if we are ramping, we must back-off
; We don't care if its transient!  dbb 12-23-98
;  -- well, okay, we do care..
;  if this is the first warning, we send out a diagnostic.
;  if this is the last warning, we power off.
    LOADOFF 0Eh               ; point to trigger sample counter
    MOVX   A,@DPTR            ; get the current value
    JZ     SETHOLDOFF         ; 0 means this is the first overlimit sample
    DEC    A                  ; decrement by one to account for this sample
    MOVX   @DPTR,A            ; update the decremented counter
    JZ     PWROFF             ; samples are simply overlimit too long
UPDTRIGC:
    AJMP   HISTO_SAMPLE       ; drop out, but not before tallying
SETHOLDOFF:
    LOADOFF 6                 ; get diagnostic code in DPTR
    CALL   REPORT_DIAGNOSTIC  ; overlimit detected, starting trigger holdoff
    CLR    A                  ; offset is zero, A,R1 <- 0
    LOADOFF 10h               ; get persistence param in DPTR
    MOV    A,DPL              ; fetch persistence param from table
; note we handle 8-bit persistence param only
;    MOV    A,#20              ; load ACC with the number of holdoff samples
    LOADOFF 0Eh               ; point to trigger sample counter
    MOVX   @DPTR,A            ; update the decremented counter
    AJMP   UPDTRIGC           ; load trigger counter with starting value

; -----------------------------------------------------------------------
STOPRAMP:
    CALL   STOP_RAMP          ; always sets C
; -----------------------------------------------------------------------
M_TRIGD:                      ; C  is set when current is less than max
    JNC    S_TRIGD            ; max triggered.
; -----------------------------------------------------------------------
; Else, the sample is normal and we simply report the actual reading
    LOADOFF 4                 ; get pointer to housekeeping in DPTR
    MOVX   @DPTR,A            ; sample to telemetry
; sample is normal, we reset any pending trigger by putting zero in counter
    LOADOFF 0Eh               ; point to trigger sample counter
    CLR    A                  ; zero, for reset of trigger counter
    MOVX   @DPTR,A            ; good sample, reset trigger counter

; -----------------------------------------------------------------------
; Histograms are 128 32-bit bins.  This requires 512 bytes, ie 200h, or
;  address offsets from 0 thru 1FFh.  So a bin may require both lower and
;  upper bytes of DPTR, so we use the carry flag.
HISTO_SAMPLE:
$IF (ZAPCANDIDATE)
    JB     SAA_FLAG,TESTiCOMPLETE ; flag used to disable record-keeping
; added dbb 9-4-97 HV_I current sampling --> histogram
    CLR    C                  ; make sure we don't add a carry
    JB     LASTSAMPLE,LAST_SAMPLE  ; when bit is set, we record sample
    JNB    HV_ON_BIT,TESTiCOMPLETE ; histogram only when power is on
LAST_SAMPLE:
    FETCHX ISAMPLE            ; be sure HVI sample is in A
    LOADOFF 0Ch               ; DPTR to start of sample storage area
;
; compute hist bin and tally, A is hvix
; A is sample, DPTR is histogram bin 0
    ANL    A,#0FEh            ; zap low-order bit, map odd to even
    RLC    A                  ; multiply by 2, carry in C
;    ADDC   A,DPL              ; add sample offset to lower part of dest ptr
; dbb 1-7-99 we assume DPL is 0, save a few cycles
    MOV    DPL,A              ;   and save it back to the DPTR register
    CLR    A                  ; zero
    ADDC   A,DPH              ; add the carry to the high order byte of ptr
    MOV    DPH,A              ;   and save it back to the DPTR register
;
; tally bin pointed-to by DPTR
;   dptr = histhvix + (2 * hvix)
    CALL   INCREMENT_WORD     ; tally bin
    JNC    NO_ROLL            ; check for carry to next word
    INC    DPTR               ; ok, point to next word
    CALL   INCREMENT_WORD     ; tally bin
    CLR    C                  ; make sure we don't add a carry
NO_ROLL:
;
; time-domain sample recording.
; increment sidxhvix, and mask upper byte with 03, so max is 03FF
    FETCHX ISAMPLE            ; be sure HVI sample is in A
    PUSH   ACC                ; store HVI sample
; then add to samphvix -- addition of two words!
    FETCHX SIDXI+1            ; upper byte to A
    PUSH   ACC                ; save upper byte
    FETCHX SIDXI              ; lower byte to A
    LOADOFF 0Ah               ; point to start of sample storage area
    ADDC   A,DPL              ; add sample offset to lower part of dest ptr
    MOV    DPL,A              ;   and save it back to the DPTR register
    POP    ACC                ; restore upper byte
    ADDC   A,DPH              ; add the carry to the high order byte of ptr
    MOV    DPH,A              ;   and save it back to the DPTR register
    POP    ACC                ; restore HVI sample
    MOVX   @DPTR,A            ; load value to memory
$ENDIF

; -----------------------------------------------------------------------
TESTiCOMPLETE:
    POP    0                  ; Restore R0
    RET                       ; CHECK_I

;*****************************************************************************
INCSPTR:                      ; increment sample index
    PUSH   ACC                ; save, holds HV_IMAX
    MOV    DPTR,#SIDXI        ; fetch index to sample buffer
    CALL   INCREMENT_WORD     ; index into circular buffer
    ANL    A,#03h             ; A has upper byte, so we mask it for mod 0x400
    MOVX   @DPTR,A            ;  and save it back to the DPTR register
    POP    ACC                ; restore HVI_MAX
    RET                       ; INCSPTR

;*****************************************************************************
; This routine is called at 1000, 166, or 21 Hz, depending on interrupt and
; timer mode settings.
; We check HV_I high-voltage current on both sides.
; If the reading is ever 255, then we power off the HV.
; If the reading is greater than or equal to threshold, then we power off.
CHECK_HV_I:
    CALL   INCSPTR            ; increment sample index
    MOV    DPTR,#HVIAINFO
    CALL   CHECK_I            ; sample, record, and trigger
    MOV    DPTR,#HVIBINFO
    CALL   CHECK_I            ; sample, record, and trigger
    MOV    DPTR,#AUXIINFO
    CALL   CHECK_I            ; sample, record, and trigger
; DPTR is pointing to an address D000-D3FF, somewhere in SAMPAUXI buffer

$IF SAMPLETIMESTAMPS
; --- we can decide whether to store timestamp info
    JB     LASTSAMPLE,DOTHIS  ; even when HV off, we record sample
    JNB    HV_ON_BIT,SKIPTHIS ; histogram only when power is on

; --- store timestamp info in SAMPTIME buffer 400h bytes in SIDX ---
DOTHIS:
; then add to samphvix -- addition of two words!
    FETCHX SIDXI+1            ; upper byte to A
    PUSH   ACC                ; save upper byte
    FETCHX SIDXI              ; lower byte to A
    MOV    DPTR,#SAMPTIME     ; point to buffer for storing timestamp data
    ADDC   A,DPL              ; add sample offset to lower part of dest ptr
    MOV    DPL,A              ;   and save it back to the DPTR register
    POP    ACC                ; restore upper byte
    ADDC   A,DPH              ; add the carry to the high order byte of ptr
    MOV    DPH,A              ;   and save it back to the DPTR register
    MOV    A,CL               ; fetch current PCA timer value (low byte)
    MOVX   @DPTR,A            ; load value to memory
SKIPTHIS:
$ENDIF

; LASTSAMPLE is used to get the trigger event recorded.  dbb 1-1-99
; we want to record some samples after the trigger
    JNB    LASTSAMPLE,XTRA_SAMPLE ; update the sample counter only on trigger
    DJNZ   HVI_DELAY,XTRA_SAMPLE  ; no more than 256 samples recorded
    CLR    LASTSAMPLE         ; this sample is recorded, even after power-off
XTRA_SAMPLE:
    RET                       ; CHECK_HV_I

$IF DEGAP
    FROGS_CODE 1593           ; nops fill extra space
    TRAP_CODE     1           ; AUTONOMY SEGMENT CODE
$ENDIF

;*****************************************************************************
MAINLOOP SEGMENT CODE PAGE
         RSEG MAINLOOP

; This is the upload entry point, for starting a version of this code that
; has been uploaded.
REENTRY:
    NOP                       ; debug place to put monitor
    CLR    EA                 ; be sure interrupts are turned off
; Ensure stack properly initialized
    MOV    SP,#STACK          ; Set up stack

; Now we do all the initialization required to ensure we can run without
;  changing the states of the HV.
    CALL   LOCALINIT          ; a simple, non-reset init saves most states
    CALL   MAINROUTINE        ; start mainloop
    JMP    SOFT_RESET         ; should never happen! but we trap it here.

;*****************************************************************************
LOCALINIT:                    ; a simple, non-reset init saves most states
    CLR    EA                 ; be sure interrupts are turned off
    SETB   CMD_RESET          ; inactive Actel reset

; Init this flag, which determines if a block of text is okay to copy
    CLR    F0                 ; flag used to indicate okay to copy xfer data

; removed to make room for other debug code
; Turn off LEDS
    CLR    A                  ; clear LEDS
    CALL   OUT_LEDS           ; clear LEDS
    MOV    LEDimage,A         ; and make image reflect LED state
    MOV    LAST_CH,A          ; save for rollover test

; Zap command buffer to prevent execution of whatever was left over
    CLR    A                  ; zero
    STOREX RS17               ; zap anything left in command buffer
    STOREX CMDIMAGE           ; this starts the command copy to image process.

    CALL   RXD0READ           ; Clear BUSY
    CALL   RXD1READ           ; Clear BUSY

; Since the CRC  calculating machine uses pointers to routines, it is
; important that the data structures be properly initialized.
    CALL   INIT_TEST_BKGRND   ; clear GF0, start background activity

; Suppress the CRC checking machine from reporting recent changes to code.
    CALL   ZAPCODECRC	      ; avoid diagnostics

; Display current version somewhere
    JB     nVERBOSE,SKIP_VERS
    CALL   SIO_VERSION
    CALL   SIO_CRLF
    SETB   nVERBOSE           ; per UPLOAD REVIEW dbb 2-5-99
SKIP_VERS:
    ASSIGNX tDP_VERSION,VNUMBER  ; 27 32

$IF DEBUGGING
; dbb 12-1-99 debug change timer value
    MOV    A,TMOD             ; fetch current Timer Mode Control Register
    XRL    A,#1               ; toggle bit 0, Timer 0 M0 Mode 0/1
    MOV    TMOD,A             ; update modified Timer Mode Control Register
$ELSE
    SPARE_CODE 6
$ENDIF
    CALL   HKPFULL            ; debug dbb 12-13-99 full packets while waiting
    CALL   IVTPATCH           ; copy PROM ivt to 8k RAM
    CALL   IVTINDIR           ; copy indirect ivt to 32k RAM
    SETB   ESS_FLAG           ; dbb debug 5-18-00
    SETB   EA                 ; enable interrupts
    RET                       ; LOCALINIT a simple, non-reset init

;*****************************************************************************
; Display RAM/ROM indicator on LEDS
LEDRAMROM:
    MOV    DPTR,#LEDRAMROM    ; get a nearby address
    MOV    A,DPH              ; get the high byte, bit 6 indicates uploaded
    ANL    A,#40h             ; turn off other bits
    SWAP   A                  ; change position of that bit
    RL     A                  ; change position of that bit * moved dbb 3-30-00
    MOV    R0,A               ; save bit mask
    FETCHX LEDS               ; fetch current LEDS -- load DPTR
    MOV    A,LEDimage         ; use internal copy
    ORL    A,R0               ; turn on the bit (if set)
    MOVX   @DPTR,A            ; update the bit
    MOV    LEDimage,A         ; update internal copy
    STOREX tLED_IMAGE         ; save copy to telemetry
; and indicate in STATUS_BITS2
    MOV    A,R0               ; boolean interpretation: zero=lower code
    CLR    CODESpace          ; assume Lower Code Space
    JZ     notUpper           ; check if bit is set
    SETB   CODESpace          ; then Upper Code Space
notUpper:
    RET                       ; LEDRAMROM

$EJECT
;*****************************************************************************
DMPPACKET:
    MOV   DPTR,#TS01          ; start address of block to xmit
    AJMP  SHKPT               ; send it!
HKPPACKET:
    MOV   DPTR,#TS17          ; start address of block to xmit
SHKPT:
    MOV   R0,#4               ; nested loop required for >255 iterations
SHKP0:
    MOV   R1,#128	      ; 4 * 128 = 512 words = 1024 bytes
SHKP1:
    CALL  SENDHKP             ; dptr points to value
    INC   DPTR                ; SENDHKP sent two bytes of data
    INC   DPTR		      ;  so we advance pointer by two.
    DJNZ  R1,SHKP1            ; Loop, 
    DJNZ  R0,SHKP0	      ;  and loop, until all 512 words are sent.
    CLRLEDS 10h               ; signal activity at LEDs
    RET                       ; HKPPACKET

;*****************************************************************************
HKPACTIVITY:                  ; do everything involved in hkp
; Send a whole housekeeping packet, 512 32-bit words.
    CLRLEDS 060h              ; inform user of this error
    CALL   CHECK_STACK        ; diagnostic only -- no repairs
    CALL   HKPUPDATE          ; write tlm to housekeeping
    CALL   HKPPACKET          ; write housekeeping out 3-wire interface
; set gpflag to turn on in 1 second (for galex only)
    CALL   HKP_SECOND         ; else send hkp again in a second iff GALEX
; clear DCE_ERR every second after it was sent
    ASSIGNX tLFDPERF,0        ; LFDPERF
    STORNEXT                  ; high byte too, LFDPERF
    FETCHX tLFDERR            ; look at current HST error list
    JZ     NOZAPPING          ; if empty we do nothing
    CLR    A                  ; else we zap the HST error list
    STOREX tLFDERR            ; LFDERR
    STORNEXT                  ; zero next byte too
    STORNEXT                  ; zero next byte too
    STORNEXT                  ; zero next byte too
    STORNEXT                  ; zero next byte too
    STORNEXT                  ; zero next byte too
    STORNEXT                  ; zero next byte too
    STORNEXT                  ; zero next byte too
NOZAPPING:
    RET                       ; HKPACTIVITY do everything involved in hkp

;*****************************************************************************
CHECKGP:                      ; drive housekeeping task timing
; Check flag that indicates its time to send a housekeeping packet
    JBC    GPFLAG,GPTICK      ; should happen autonomously or on command
    JMP    NOHKPACTIV         ;   assumes GPFLAG is set periodically
GPTICK:
    CALL   HKPACTIVITY        ; do everything involved in hkp
NOHKPACTIV:
    RET                       ; CHECKGP drive housekeeping task timing

HKPUPDATE:                    ; write tlm to housekeeping

; These timestamps are used to support a test to verify that housekeeping
; packets are delivered intact and contemporaneously  dbb 3-29-00
$IF XXX
    MOV_TIMER ENDPACKETTIMESTAMP ; Save timer value - hkpupdate
    MOV_TIMER STAPACKETTIMESTAMP ; Save timer value - hkpupdate dbb debug 4-1-00
$ENDIF
    MOV    A,RESETCTR         ; get some visibility on this variable
    STOREX tRESETCOUNTER      ; TS00+83Ch    ; picked a good location...

; CHECK_COMMAND measured at 0.5 to 0.6ms
    CALL   CHECK_COMMAND      ; Process any waiting commands

    MOV    DPTR,#UPDATETABLE  ; point to a table of sources, dests, and lengths
    CALL   TABLE_COPY

; added dbb 12-22-98 to support latching of housekeeping in the event of
;   HVI overcurrent.  per ggaines.
    JB     MUX_FLAG,NOUPDMUX  ; debug db 3-10-00
    CALL   UPDATE_MUX         ; Copy MUX to subaddress 27
NOUPDMUX:
    CALL   ESSENTIAL          ; Assorted monitors

; Copy status bits from internal memory to hkp
    MOV    A,#ACT1_BIT        ; This is a bit-address!
    PUSH   B
    MOV    B,#8               ; 8 bits per byte
    DIV    AB                 ; compute number of bytes from base bit-area
    ADD    A,#20h             ; convert bit address to byte address
    MOV    R0,A               ; and let R0 be a pointer to that address
    MOV    A,B                ; make sure LOC26BITS is properly aligned
    POP    B
    MOV    A,@R0              ; fetch lower byte
    STOREX tSTATUS_BITS0      ; 27 26             STATUS_BITS0
    CALL   NEXTBYTE	      ; 27 26 upper byte
    CALL   NEXTBYTE           ; 27 27		  STATUS_BITS1
    CALL   NEXTBYTE	      ; 27 27 upper byte

; we clear this flag every time, even though it is used only for REDUCE/RESUME
    CLR    ASSERTED	      ; we don't expect this unless it was commanded

    CALL   MEMORYMONITORS     ; update hkp byte values
    MOV    A,HVRAMP           ; Report current ramp setting
    STOREX tDHRAMPT           ;  written out to hkp
; First, update some of the bits about to be moved to telemetry...
    MOV    A,CCAPM4           ; Watchdog Disabled?  look at h/w register
    ANL    A,#48h             ; mask out reserved bit(s)
    CLR    C                  ; assumed enabled
    JNZ    NOT_DISABLED       ; presumed 48h when enabled
    SETB   C		      ;  found disabled
NOT_DISABLED:
    MOV    WATCHDOG_STATE,C   ; prepare for output thru STATUS_BITS2
    RET                       ; HKPUPDATE write tlm to housekeeping
$EJECT
;*****************************************************************************
ONEHZACTIVITY:                ; one per second activity
    CALL   SAA_TEST           ; look for excessive counts over some interval
    CALL   CHECK_MOTOR_TICK   ; We assume this happens exactly once per second
    CALL   UPDATE_CTRS        ; Copy counters to subaddress 25
    CALL   LEDRAMROM          ; let LEDs reflect running code area
    TOGLEDS 80h               ; display activity on LEDS
    MOV    DPTR,#LastErrInfo  ; debug dbb 5-19-00
    CALL   INCREMENT_WORD     ; debug dbb 5-19-00
    RET                       ; ONEHZACTIVITY one per second activity

;*****************************************************************************
CHECKCMD:                     ;	check for command opcodes
; Command traffic may imply some timing if interrupts are turned off.
; For compatability with FUSE, we assume 1Hz commanding.
;
; Now we do the regular activity loop only if there is a command from GSE/IDS
; This section detects IDS/GSE activity by checking for a change in the
;  first byte of RS17 (which holds commands to DPU).  It is possible that
;  this code will start processing the command before it is completely written
;  to RS17, decide the command is in error, and therefore ignore it.
    FETCHX CMDIMAGE           ; fetch command
    JZ     NOTRAFFIC          ; if zero, buffer in power-on state
    AJMP   SOMETRAFFIC
; We feed the watchdog autonomously until first command packet
NOTRAFFIC:
    MOV    A,CCAPM4           ; watchdog control register 48h or 0
    JZ     NOCMD1HZ           ; no need to feed if watchdog disabled
    CALL   FEED_DOG           ; no watchdog reset until first message
    AJMP   NOCMD1HZ           ; don't check for command
SOMETRAFFIC:
    JNB    PROJECT,STAY_FULL
    JNB    ESS_FLAG,STAY_FULL ; per jchen 5-17-00, galex packet size control
    CLR    HKP_FULL           ; reset because we are in GALEX mode.
STAY_FULL:

; Since opcode is not zero, check if it is a new opcode
; ACC still holds command byte...
    CJNE   A,#NULL_CMD,CMDACTIVITY ; Is there a command to process?
    AJMP   NOCMD1HZ           ; not a command

; Some kind of command op-code has been detected.
CMDACTIVITY:
; GPFLAG triggers command handling and housekeeping response
    SETB   GPFLAG             ; force a hkp packet in response to command
; If interrupts are turned off then we assume that commands are arriving
;  at a rate of one-per-second, ala FUSE.  So we do our one-second activities
;  now.  dbb 12-5-99
    JB     EA,NOCMD1HZ        ; if interrupts, its timer driven
    CALL   ONEHZACTIVITY      ; one per second activity
    NOP
NOCMD1HZ:
    RET                       ; CHECKCMD check for command opcodes

;*****************************************************************************
CHECK1HZ:                     ; door activity, autonomous protection, counters
; Check one-second timer flag for 1Hz activities
    JBC    CLOCK_TOCK,oneTOCK ; should happen autonomously every 1000 ms
    AJMP   noTOCK
oneTOCK:
    CALL   ONEHZACTIVITY      ; one per second activity
noTOCK:
    RET                       ; CHECK1HZ door activity, autonomous protection, counters

$EJECT
;*****************************************************************************
CHECKFAST:                    ; ramping only
; Check fastest timer flag for frequent activities
    JBC    CLOCK_TICK,oneTICK ; should happen autonomously every 49/6 ms
    AJMP   noTICK
oneTICK:
    CALL   CHECK_RAMP         ; autonomous HV ramping
noTICK:
    CALL   CHECK_HV_I         ; autonomous HV I limit checking added 4-21-00
    RET                       ; CHECKFAST ramping only

;*****************************************************************************
BKGACTIVITY:
; If there is nothing else to do...
                              ; Check flag indicating incoming command traffic
    CALL   CHECKRXDFLAG       ; detect opcode, stash command buffer
    CALL   BACKGROUND         ; background CRC activity & MON51
    RET                       ; BKGACTIVITY

$EJECT

;*****************************************************************************
; Top of mainloop.
; Check for each kind of event-driven activities.  
MAINROUTINE:		      ;Mainroutine == MainLoop
                              ; Check flag that indicates it is time to send a housekeeping packet
    CALL   CHECKGP            ;   drive housekeeping task timing, handle commands
                              ; Check for a command opcode and set activity flag
    CALL   CHECKCMD           ;	  check for command opcodes and set GPFLAG
                              ; Check one-second timer flag for 1Hz activities
    CALL   CHECK1HZ           ;   door activity, count rate limit, get counters
                              ; Check fastest timer flag for frequent activities
    CALL   CHECKFAST          ;   ramping only
                              ; And finally, a background activity
    CALL   BKGACTIVITY        ;   mon51, current limit, crc checking
                              ; Again!
; count number of times/second we execute this loop
    MOV    DPTR,#tLFDPERF     ; LFDPERF
    CALL   INCREMENT_WORD     ; DPU command counter
    AJMP   MAINROUTINE	      ;   loop while waiting for command

$IF DEGAP
     FROGS_CODE    1
     TRAP_CODE     1          ; MAINLOOP SEGMENT CODE
$ENDIF

;*****************************************************************************
TRAPSEG SEGMENT CODE PAGE
        RSEG TRAPSEG

$IF DEGAP
    FROGS_CODE 16380
$ENDIF
    TRAP_CODE     1

    END                       ; DPU.A51
